from Player import Player
import Choice

import os,sys
import random
import copy

def charOfPiece(piece, player):
    char = { "Pharoah" : 'k',
	    "Obelisks" : 'o',
	    "Obelisk" : 'u',
	    "Djed/" : 'j',
	    "Djed\\" : 'l',
	    "PyramidNW" : 'd',
	    "PyramidNE" : 'b',
	    "PyramidSW" : 'q',
	    "PyramidSE" : 'p'
	    }[piece.type]
    if player == 0:
	return char
    else:
	return char.upper()

class DumbUI(Player):
    def rotated(self, c):
	# Don't rotate board (we'd have to rotate the pieces too...)
	return c
	#if self.player == 1:
	    #return ((self.state.width - 1) - c[0], (self.state.height - 1) - c[1])
	#else:
	    #return c

    def drawState(self):
	cols = map(chr, range(ord('a'),ord('a')+self.state.width))
	#if self.player == 1:
	    #cols.reverse()
	print ""
	print "  "+ ''.join(cols) +"  "
	print "  "+ " "*(self.state.width-1) + "*"
	for j in range(self.state.height):
	    #if self.player == 1: row = self.state.height - j
	    #else: row = j+1
	    row = j+1
	    print "%d %s %d" % (row,
		    reduce(lambda x,y:x+y,map(lambda i:
			self.charOfSquare(self.state, self.rotated((i,j))), range(self.state.width))),
		    row)
	print "  *"
	print "  "+ ''.join(cols) +"  "
	print ""

    def gameEnd(self):
	if self.state.dead[0]:
	    if self.state.dead[1]:
		text = "Draw"
	    else:
		text = "White wins"
	elif self.state.dead[1]:
	    text = "Black wins"
	else:
	    text = "Draw"
	self.getKey(text)

    def getKey(self, prompt=""):
	return raw_input(prompt)

    def charOfSquare(self, state, coord):
	piece = state.pieceIn(coord)
	if piece:
	    return charOfPiece(piece, piece.player)
	return " "

    def getChoice(self, pl):
	while True:
	    moveStr = raw_input("Enter move: ")
	    # TODO: algebraic notation
	    to = frm = None
	    dir = 0
	    unstack = 0
	    try:
		from string import replace
		moveStr = replace(moveStr,' ','')
		moveStr = replace(moveStr,'-','')
		frm = (ord(moveStr[0])-ord('a'), ord(moveStr[1])-ord('1'))
		if moveStr[2] in "<>":
		    to = frm
		    dir = (-1)**(moveStr[2] == '<')
		else:
		    to = (ord(moveStr[2])-ord('a'), ord(moveStr[3])-ord('1'))
		    if moveStr[4:5] == "U":
			unstack = 1
	    except:
		print "Syntax error"
		continue
	    if not (self.state.inBounds(frm) and self.state.inBounds(to)):
		print "Syntax error"
		continue
	    choice = Choice.Choice(frm, to, dir, unstack)
	    if not self.state.checkLegalChoice(choice, pl):
		print "Illegal move"
		continue
	    return choice
