import Choice
import Network
from State import State

class Player(object):
    def __init__(self, socket, isServer, gameOpts, opts):
	self.socket, self.isServer, self.gameOpts = socket, isServer, gameOpts

	self.scores = [0,0]
	self.initState()

    def interact(self):
	self._interact()

    def _interact(self):
	self.player = int(self.isServer)^self.socket.agreedRandomBit()

	self.drawAll()
	self.refresh()

	while True:
	    if self.state.simultaneous:
		choice = self.getChoice(self.player)
		theirChoiceStr = self.socket.exchangeFixedSimul(choice.netStr())
		theirChoice = Choice.netStrToChoice(theirChoiceStr)

		self.state.update(choice, self.player)
		self.state.update(theirChoice, 1-self.player)
		self.drawState()
		self.refresh()
	    else:
		if self.state.turn == self.player:
		    choice = self.getChoice(self.player)
		    self.state.update(choice, self.player)
		    self.drawState()
		    self.refresh()

		    choiceStr = choice.netStr()
		    self.socket.send(choiceStr)

		else:
		    theirChoiceStr = self.socket.recvFixed(Choice.Choice.NETSTR_LEN)
		    theirChoice = Choice.netStrToChoice(theirChoiceStr)
		    self.state.update(theirChoice, 1-self.player)
		    self.drawState()
		    self.refresh()

	    if self.state.dead[0] or self.state.dead[1]:
		for pl in (0,1): self.scores[pl] += bool(self.state.dead[1-pl])
		self.gameEnd()
		self.player = 1-self.player
		self.initState()
		self.drawEdges()
		self.drawScores()
		self.drawState()
		self.refresh()


    def initState(self):
	self.state = State(self.gameOpts)

    def refresh(self):
	pass

    def drawAll(self):
	self.drawEdges()
	self.drawState()
	self.drawScores()

    def drawEdges(self):
	pass

    def drawState(self):
	pass

    def drawChoice(self, pl, choice=None, oldChoice=None):
	pass

    def drawScores(self):
	pass

    def gameEnd(self):
	pass

    def getChoice(self, pl):
	raise RuntimeError("Unimplemented")
